package com.ktg.iscs.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ktg.iscs.domain.IsSop;
import com.ktg.iscs.domain.dto.sop.AddMarsSopDTO;
import com.ktg.iscs.domain.dto.sop.PageSopDTO;
import com.ktg.iscs.domain.vo.sop.ImportSopVO;
import com.ktg.iscs.domain.vo.sop.MarsSopDetailVO;
import com.ktg.iscs.domain.vo.sop.SopPageVO;

import java.util.List;

/**
 * SOP信息Service接口
 *
 * @author cgj
 * @date 2024-10-18
 */
public interface IIsMarsSopService extends IService<IsSop>
{
    /**
     * 查询SOP信息
     *
     * @param sopId SOP信息主键
     * @return SOP信息
     */
    MarsSopDetailVO selectIsMarsSopBySopId(Long sopId);

    /**
     * 查询SOP信息列表
     *
     * @param isSop SOP信息
     * @return SOP信息集合
     */
    List<IsSop> selectIsMarsSopList(IsSop isSop);

    /**
     * 新增SOP信息
     *
     * @param dto SOP信息
     * @return 结果
     */
    Boolean insertIsMarsSop(AddMarsSopDTO dto);

    /**
     * 修改SOP信息
     *
     * @param dto SOP信息
     * @return 结果
     */
    Boolean updateIsMarsSop(AddMarsSopDTO dto);

    /**
     * 批量删除SOP信息
     *
     * @param sopIds 需要删除的SOP信息主键集合
     * @return 结果
     */
    Boolean deleteIsMarsSopBySopIds(String sopIds);

    /**
     * 删除SOP信息信息
     *
     * @param sopId SOP信息主键
     * @return 结果
     */
    int deleteIsMarsSopBySopId(Long sopId);

    /**
     * sop分页查询
     * @param page
     * @param dto
     * @return
     */
    Page<SopPageVO> getIsMarsSopPage(PageSopDTO dto, Page<IsSop> page);

    Boolean updateIsMarsSopIndex(IsSop isSop);

    String importSop(List<ImportSopVO> itemList, boolean updateSupport, String operName);

}
